package ap;

import ap.proof.ModelSearchProver
import ap.terfor.conjunctions.{Conjunction, Quantifier}
import ap.util.Debug
import ap.parameters.GoalSettings

object FileModelSearcher {
  
  private val AC = Debug.AC_PROVER
  
}

class FileModelSearcher(reader : java.io.Reader, output : Boolean,
                        goalSettings : GoalSettings)
      extends AbstractFileProver(reader, output, Math.MAX_INT, false, goalSettings) {

  //////////////////////////////////////////////////////////////////////////////
  Debug.assertCtor(FileModelSearcher.AC,
                   (formula.constants subsetOf eliminatedConstants) &&
                   (Conjunction.collectQuantifiers(formula) subsetOf Set(Quantifier.ALL)))
  //////////////////////////////////////////////////////////////////////////////
  
  val counterModel : Conjunction = findCounterModel match {
    case ModelSearchProver.FoundModel(m) => m
    case ModelSearchProver.NoModel => Conjunction.FALSE
  }
  
}
